### Function

# EBook BookClient connect_direct

since: 3.12

#### Declaration [src]

    void
    e_book_client_connect_direct (
      ESource* source,
      guint32 wait_for_connected_seconds,
      GCancellable* cancellable,
      GAsyncReadyCallback callback,
      gpointer user_data
    )

#### Description [src]

Like e_book_client_connect(), except creates the book client for direct read access to the underlying addressbook.

When the operation is finished, `callback` will be called. You can then call `e_book_client_connect_direct_finish()` to get the result of the operation.

Available since: 3.12

This function completes asynchronously. Use `e_book_client_connect_direct_finish()` inside the `GAsyncReadyCallback` to obtain the result of the operation.

#### Parameters

`source`

  Type: `ESource`

  An `ESource`.

  The data is owned by the caller of the function.

`wait_for_connected_seconds`

  Type: `guint32`

  Timeout, in seconds, to wait for the backend to be fully connected.

`cancellable`

  Type: `GCancellable`

  Optional `GCancellable` object, or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`callback`

  Type: `GAsyncReadyCallback`

  A `GAsyncReadyCallback` to call when the request is satisfied.

`user_data`

  Type: `gpointer`

  Data to pass to the callback function.

  The argument can be `NULL`.
  The data is owned by the caller of the function.